import { defineConfig } from "vite";
import uni from "@dcloudio/vite-plugin-uni";
const Timestamp = new Date().getTime()

// https://vitejs.dev/config/
export default defineConfig({
  plugins: [uni()],
  build: {
    sourcemap: false, // 输出.map文件,默认是false
    rollupOptions: {
      output: {
        chunkFileNames:`static/js/[name].[hash]${Timestamp}.js`,
        entryFileNames: `static/js/[name].[hash]${Timestamp}.js`,
        assetFileNames: `assets/[ext]/[name].[hash]${Timestamp}.[ext]`,
      },
    }
  },
  // publicPath: './',
  // server: {
  //   proxy: {
  //     "/admin-api": { // “/api” 以及前置字符串会被替换为真正域名
  //       target: "http://47.92.245.35:5002", // 请求域名
  //       secure: false, // 请求是否为https
  //       changeOrigin: true, // 是否跨域
  //       rewrite: (path) => path.replace(/^\/admin-api/, "")
  //     }
  //   }
  // }
});
